module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(1));


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = __webpack_require__(2);
const resolverFiles = __webpack_require__(3);
const resolverModules = resolverFiles.keys().map((moduleName) => {
    return resolverFiles(moduleName);
});
const graphqlFiles = __webpack_require__(5);
const graphqls = graphqlFiles.keys().map((graphqlName) => {
    return graphqlFiles(graphqlName);
});
const resolvers = (pubsub, logger) => resolverModules.reduce((state, m) => {
    if (!m.resolver) {
        return state;
    }
    return lodash_1.merge(state, m.resolver(pubsub, logger));
}, {});
exports.resolvers = resolvers;
const typeDefs = graphqls.reduce((prev, cur) => prev.concat('\n' + cur), '\n');
exports.typeDefs = typeDefs;


/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = require("lodash");

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

var map = {
	"./git/resolver.ts": 4
};
function webpackContext(req) {
	return __webpack_require__(webpackContextResolve(req));
};
function webpackContextResolve(req) {
	var id = map[req];
	if(!(id + 1)) // check for number or string
		throw new Error("Cannot find module '" + req + "'.");
	return id;
};
webpackContext.keys = function webpackContextKeys() {
	return Object.keys(map);
};
webpackContext.resolve = webpackContextResolve;
module.exports = webpackContext;
webpackContext.id = 3;

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.resolver = (pubsub, logger) => ({
    Query: {
        getCommit(root, { ref }, ctx) {
            return ctx.gitService.getCommit(ref);
        },
        refs(root, args, ctx) {
            return ctx.gitService.getRefs();
        },
        status(root, args, ctx) {
            return ctx.gitService.status();
        },
        stashes(root, args, ctx) {
            return ctx.gitService.getStashes();
        },
        headContent(root, args, ctx) {
            return ctx.gitService.getHeadContent(args.resource);
        },
        init(root, args, ctx) {
            return ctx.gitService.init();
        },
        fetch(root, args, ctx) {
            return ctx.gitService.fetch(args.remote);
        },
        auth(root, args, ctx) {
            return ctx.gitService.getAuthData(args.id);
        },
    },
    Mutation: {
        async open(root, args, ctx) {
            ctx.gitService.setRepoPath(args.path);
            logger && logger.debug('args.path: [%s]', args.path);
            const status = await ctx.gitService.status();
            if (status.error) {
                return { setPath: { error: status.error } };
            }
            return { setPath: { error: '' } };
        },
        async close(root, args, ctx) {
            ctx.gitService.setRepoPath(null);
            return { isClosed: true };
        },
        add(root, args, ctx) {
            return ctx.gitService.add(args.paths);
        },
        pull(root, args, ctx) {
            return ctx.gitService.pull(args.options);
        },
        push(root, args, ctx) {
            return ctx.gitService.push(args.remote, args.name, args.options);
        },
        unstage(root, args, ctx) {
            return ctx.gitService.reset(args.paths);
        },
        clean(root, args, ctx) {
            return ctx.gitService.discartChanges(args.paths);
        },
        commit(root, args, ctx) {
            return ctx.gitService.commit(args.message, args.opts);
        },
        commitAll(root, args, ctx) {
            return ctx.gitService.commitAll(args.message, args.opts);
        },
        stash(root, args, ctx) {
            return ctx.gitService.stash(args.message);
        },
        unstash(root, args, ctx) {
            return ctx.gitService.unstash(args.index);
        },
        sync(root, args, ctx) {
            return ctx.gitService.sync(args.options);
        },
        clone(root, args, ctx) {
            return ctx.gitService.clone(args.url, args.path, args.options);
        },
        createBranch(root, args, ctx) {
            return ctx.gitService.createBranch(args.name, args.checkout);
        },
        tag(root, args, ctx) {
            return ctx.gitService.tag(args.name, args.message);
        },
        deleteBranch(root, args, ctx) {
            return ctx.gitService.deleteBranch(args.name);
        },
        checkout(root, args, ctx) {
            return ctx.gitService.checkout(args.name);
        },
        merge(root, args, ctx) {
            return ctx.gitService.merge(args.branch);
        },
        saveUser(root, args, ctx) {
            return ctx.gitService.saveUserData(args.login, args.endpoint);
        },
        undoLastCommit(root, args, ctx) {
            return ctx.gitService.undoLastCommit();
        },
    },
});


/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

var map = {
	"./git/schema.graphqls": 6,
	"./git/types.graphql": 7
};
function webpackContext(req) {
	return __webpack_require__(webpackContextResolve(req));
};
function webpackContextResolve(req) {
	var id = map[req];
	if(!(id + 1)) // check for number or string
		throw new Error("Cannot find module '" + req + "'.");
	return id;
};
webpackContext.keys = function webpackContextKeys() {
	return Object.keys(map);
};
webpackContext.resolve = webpackContextResolve;
module.exports = webpackContext;
webpackContext.id = 5;

/***/ }),
/* 6 */
/***/ (function(module, exports) {

module.exports = "\n\n\n# Root Query\nextend type Query {\n    getCommit(ref: String!): Commit\n    status: IGitStatusResult\n    refs: [Ref]\n    init: IGitStatusResult\n    fetch: IGitStatusResult\n    statusChanges: [TreeGroup]\n    stashes: [Stash]\n    headContent(resource: String!): IGetHead\n    auth(id: String!): UserAuth\n}\n\nextend type Mutation {\n    add(paths: [String]): IGitStatusResult\n    close: IClosed\n    deleteBranch(name: String!): IGitResult\n    clone(url: String!, path: String!, options: ICloneOptions!): IGitResult\n    createBranch(name: String!, checkout: Boolean!): IGitResult\n    commit(message: String!, opts: ICommitOptions): IGitStatusResult\n    commitAll(message: String!, opts: ICommitOptions): IGitStatusResult\n    clean(paths: [String]): IGitStatusResult\n    pull(options: IPullOptions): IGitStatusResult\n    push(remote: String, name: String, options: IPushOptions): IGitResult \n    stash(message: String): IGitStatusResult\n    tag(name: String!, message: String): IGitResult\n    sync(options: ISyncOptions): IGitStatusResult\n    open(path: String): IGitPathResult\n    checkout(name: String): IGitStatusResult\n    merge(branch: String!): IGitStatusResult\n    saveUser(login: String!, endpoint: String): ISaveUser\n    unstash(index: Int): IGitStatusResult\n    undoAll: IGitStatusResult\n    unstage(paths: [String]): IGitStatusResult\n    undoLastCommit: IGitStatusResult\n}\n"

/***/ }),
/* 7 */
/***/ (function(module, exports) {

module.exports = "type Commit {\n  hash: String!\n  message: String!\n}\n\nenum RawServiceState {\n  OK\n  GitNotFound\n  Disabled\n}\n\ntype IGitStatusResult {\n   currentBranch: String,\n   currentTip: String,\n   currentUpstreamBranch: String,\n   branchAheadBehind: IBranchAhead,\n   status: [IWorkingDirectory],\n   stdout: String,\n   stderr: String,\n   exitCode: Int,\n   gitErrorDescription: String\n}\n\ntype IBranchAhead {\n  ahead: Int,\n  behind: Int\n}\n\ntype IWorkingDirectory {\n  path: String,\n  oldPath: String,\n  x: String,\n  y: String\n}\n\n\ntype IGitServiceError implements Error {\n  stack: String\n  gitErrorCode: String!\n}\n\ninterface Error {\n  stack: String\n}\n\ntype GitConfiguration {\n\tenabled: Boolean\n\tpath: String\n\tautorefresh: Boolean\n\tautofetch: Boolean\n\tenableLongCommitWarning: Boolean\n\tallowLargeRepositories: Boolean\n\tconfirmSync: Boolean\n\tcountBadge: String\n\tcheckoutType: String\n}\n\ninput IPushOptions {\n  tags: Boolean\n  setUpstream: Boolean\n  login: String\n  password: String\n}\n\nenum Status {\n  INDEX_MODIFIED,\n\tINDEX_ADDED,\n\tINDEX_DELETED,\n\tINDEX_RENAMED,\n\tINDEX_COPIED,\n\n\tMODIFIED,\n\tDELETED,\n\tUNTRACKED,\n\tIGNORED,\n\n\tADDED_BY_US,\n\tADDED_BY_THEM,\n\tDELETED_BY_US,\n\tDELETED_BY_THEM,\n\tBOTH_ADDED,\n\tBOTH_DELETED,\n\tBOTH_MODIFIED\n}\n\ntype TreeItem {\n  status: String!\n  name: String!\n  originName: String\n  path: String\n  originPath: String\n}\n\ninput TreeItemInput {\n  status: String!\n  path: String!\n  originPath: String\n}\n\ntype TreeGroup {\n  group: String!\n  items: [TreeItem]\n}\n\ninput IPullOptions {\n  login: String\n  password: String\n  rebase: Boolean\n  branch: String\n}\n\ninput ISyncOptions {\n  login: String\n  password: String\n}\n\ntype IGitResult {\n  stdout: String\n  stderr: String\n  exitCode: Int\n  gitErrorDescription: String\n}\n\ntype OpenError{\n  error: String\n}\n\ntype IGitPathResult {\n  setPath: OpenError\n}\n\n\ninput ICloneOptions {\n  login: String\n  password: String\n}\n\ninput ICommitOptions {\n  amend: Boolean,\n  signoff: Boolean\n}\n\ntype Ref {\n  type: Int,\n  name: String,\n  commit: String,\n  remote: String\n}\n\ntype Stash { \n  index: Int,\n  description: String\n}\n\ntype UserAuth {\n  login: String,\n  endpoint: String\n}\n\ntype ISaveUser {\n  id: String\n}\n\ntype IClosed {\n  isClosed: Boolean\n}\n\ntype IGetHead {\n    path: String\n    stdout: String\n}"

/***/ })
/******/ ]);
//# sourceMappingURL=index.js.map